<?php

/**
 * Smarty {template_event name=""} function plugin
 *
 * Type:     function<br>
 * Name:     templateEvent<br>
 *
 * @param array $params
 * @param Smarty $Smarty
 *
 * @return string|null
 * @author PCSG
 *
 */
function smarty_function_template_event($params, $Smarty)
{
    if (!isset($params['name'])) {
        return '';
    }

    $Collector = new Quiqqer\Engine\Collector();
    $Template  = null;

    /* @var $Template \QUI\Template */
    if (isset($params['Template'])) {
        $Template = $params['Template'];
    }

    $name   = $params['name'];
    $assign = false;

    if (isset($params['assign'])) {
        $assign = $params['assign'];
    }

    unset($params['name']);
    unset($params['assign']);

    \array_unshift($params, $Collector);

    try {
        if ($Template) {
            // add all templates to ignore
            // but not the current
            $packages = QUI::getPackageManager()->searchInstalledPackages([
                'type' => "quiqqer-template"
            ]);

            $TemplatePackage = $Template->getTemplatePackage();
            $tpName          = '';

            if ($TemplatePackage) {
                $tpName = $TemplatePackage->getName();
            }

            foreach ($packages as $package) {
                if ($package['name'] !== $tpName) {
                    QUI::getEvents()->ignore($package['name']);
                }
            }
        }

        QUI::getEvents()->fireEvent($name, $params);
        QUI::getEvents()->clearIgnore();
    } catch (QUI\Exception $Exception) {
        QUI\System\Log::writeDebugException($Exception);
    } catch (\Throwable $Exception) {
        QUI\System\Log::writeException($Exception, QUI\System\Log::LEVEL_ERROR, [
            'name'   => $name,
            'params' => $params
        ]);
    }

    if (!$assign) {
        return $Collector->getContent();
    }

    $Smarty->assign($assign, $Collector->getContent());

    return '';
}
